@use "sass:map";
@use "sass:string";
@use "utils/functions" as utils;


/*  ## Design Tokens ##

    Design Tokens sind Variablen, die Design-Attribute wie Farben,
    Schriftgrößen, Abstände usw. repräsentieren. Sie dienen als eine 
    einzige Quelle der Wahrheit für Design-Attribute über verschiedene 
    Plattformen und Geräte hinweg und ermöglichen eine konsistentere 
    Benutzeroberfläche und ein effizienteres Design-System.

    * Token Ebenen *
    ** Primitives **
    Primitives Tokens sind die grundlegendsten Tokens. Sie sind plattformübergreifend
    gleich und bilden sozusagen die Bausteine des Designs. Sie umfassen z.B.
    Dimensionen, Farben, Schriftarten etc. Primitives referenzieren IMMER auf echte
    Werte.

    ** App Tokens **
    Die App Tokens definieren "Entscheidungen". Wie sieht mein Background aus, wie 
    die Brand Color etc. Sie werden semantisch benannt. Sie referenzieren IMMER auf einen primitive Token.

    Bei den App Tokens gibt es 2 Arten von Tokens. Die Simple Tokens referenzieren auf einen Wert, die 
    Composit Tokens referenzieren auf mehrere Werte, wobei der Key immer eine CSS Eigenschaft sein sollte.

    ** Component Tokens **
    Component Tokens sind die optionale 3. Ebene. Sie referenzieren auf App Tokens oder Primitives und werden für jede Component definiert,
    bei der es sinnvoll ist. Die Component Tokens werden component-spezfisch benannt und können optional geladen werden.  
    
    * Modes *
    Es können mehrere Modes definiert werden. Modes werden nur bei den App Tokens unterstützt. Pro Mode können unterschiedliche Token Werte 
    definiert werden. Wichtig bei den Modes: Es müssen ALLE Tokens im Default Mode definiert werden. In den anderen Modes müssen nur die Tokens 
    angegeben werden, die vom Default abweichen.

    * Variations *
    Adamantium UI bietet auf Component Ebene ein Variation System. Damit kann man pro Component mehrere Variants definieren. 
    So kann man bei einer Liste z.B. neben der Standard Version auch eine "narrow" Variante definieren.
    Da bei Components auf App Tokens referenziert werden sollte, kann man Components ideal mit Modes kombinieren, um so 
    flexible Layouts zu ermöglichen.

*/

$token-identifier: "adm-";


$primitive-tokens: (

    // primitive category
    dimension: (
        1: 1,
        2: 2,

        4: 4,
        8: 8,

        12: 12,
        16: 16,
        20: 20,
        24: 24,
        28: 28,
        32: 32,
        36: 36,
        40: 40,
        
        48: 48,
        56: 56,
        64: 64,
        72: 72,
        80: 80,
        96: 96,   
        112: 112,
        128: 128,
        256: 256,
        
        // breakpoints & widths
        512: 512,
        768: 768,
        1024: 1024,
        1280: 1280,
        1600: 1600,
        2160: 2160,
        2560: 2560,
        3840: 3840,
    ),
    color: (
        white: hsl(0, 0%, 100%), // values in HSL
        black: hsl(0, 0%, 0%), // values in HSL
    ),
    opacity: (
        20: 0.2,
        40: 0.4,
        80: 0.8
    ),
    font-family: (
        base: 'system-ui,-apple-system,"Segoe UI",Roboto,"Helvetica Neue",Arial,"Noto Sans","Liberation Sans",sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji"',
        headlines: '"Roboto Bold", Arial, sans-serif',
    ),
) !default;


$app-tokens: (
    default: (
        // app
        app: (

        ),

        // layout
        grid: (
            
        ),
        container: (

        ),
        breakpoint: (

        ),
        space: (
            
        ),

        // dimensions
        size: (

        ),
        height: (

        ),
        width: (

        ),


        // visuals
        color: (

        ),
        border: (

        ),
        radius: (
            
        ),
        shadow: (
            
        ),
        elevation: (
            
        ),
        transition: (

        ),
        
        // type (composit)
        type: (
            
        ),
    ),
    // additional modes here...
    mode-1: (
        
    ),
    mode-2: (

    ),
) !default;


